Subject: Re: linux-next: build failure after merge of the final tree

From: Greg Kroah-Hartman <[email-masked]>
Date: Wed, 6 Feb 2013 09:52:05 -0800

On Wed, Feb 06, 2013 at 06:42:43PM +1100, Stephen Rothwell wrote:
> Hi all,
> 
> On Wed, 6 Feb 2013 18:30:40 +1100 Stephen Rothwell <[email-masked]> wrote:
> >
> > After merging the final tree, today's linux-next build (sparc defconfig)
> > failed like this:
> > 
> > arch/sparc/kernel/kgdb_32.c: In function 'sleeping_thread_to_gdb_regs':
> > arch/sparc/kernel/kgdb_32.c:46:9: error: implicit declaration of function 'task_thread_info' [-Werror=implicit-function-declaration]
> > arch/sparc/kernel/kgdb_32.c:46:26: error: initialization makes pointer from integer without a cast [-Werror]
> > 
> > I can only imagine that the implicit include of linux/sched.h got removed
> > in one of our include file changes. :-(
> > 
> > I have added this patch for today:
> > 
> > From: Stephen Rothwell <[email-masked]>
> > Date: Wed, 6 Feb 2013 18:26:51 +1100
> > Subject: [PATCH] sparc: explicitly include sched.h to get task_thread_info declaration
> > 
> > Signed-off-by: Stephen Rothwell <[email-masked]>
> > ---
> >  arch/sparc/kernel/kgdb_32.c | 1 +
> >  1 file changed, 1 insertion(+)
> > 
> > diff --git a/arch/sparc/kernel/kgdb_32.c b/arch/sparc/kernel/kgdb_32.c
> > index 2e424a5..dcf2108 100644
> > --- a/arch/sparc/kernel/kgdb_32.c
> > +++ b/arch/sparc/kernel/kgdb_32.c
> > @@ -5,6 +5,7 @@
> >  
> >  #include <linux/kgdb.h>
> >  #include <linux/kdebug.h>
> > +#include <linux/sched.h>
> >  
> >  #include <asm/kdebug.h>
> >  #include <asm/ptrace.h>
> 
> This was probably caused by commit 16559ae48c76 ("kgdb: remove #include
> <linux/serial_8250.h> from kgdb.h") from the tty tree.
> 
> Removing includes from include files is always fraught with this sort of
> danger :-(

Yes it is, and I caught a bunch of crazy dependancies when I fixed this
up, but now the build should be so much easier for those of us working
on the serial code, the whole tree will now not have to rebuild for no
reason at all.

Sorry for missing this one, the fix looks correct to me, I'll queue it
up in my tree, or it can go through David's.

thanks,

greg k-h